####################################################################
#
#    This file was generated using Parse::Yapp version 1.05.
#
#        Don't edit this file, use source file instead.
#
#             ANY CHANGE MADE HERE WILL BE LOST !
#
####################################################################
package Choicetool::Frontends::KConfig::Parse;
use vars qw ( @ISA );
use strict;

@ISA= qw ( Parse::Yapp::Driver );
#Included Parse/Yapp/Driver.pm file----------------------------------------
{
#
# Module Parse::Yapp::Driver
#
# This module is part of the Parse::Yapp package available on your
# nearest CPAN
#
# Any use of this module in a standalone parser make the included
# text under the same copyright as the Parse::Yapp module itself.
#
# This notice should remain unchanged.
#
# (c) Copyright 1998-2001 Francois Desarmenien, all rights reserved.
# (see the pod text in Parse::Yapp module for use and distribution rights)
#

package Parse::Yapp::Driver;

require 5.004;

use strict;

use vars qw ( $VERSION $COMPATIBLE $FILENAME );

$VERSION = '1.05';
$COMPATIBLE = '0.07';
$FILENAME=__FILE__;

use Carp;

#Known parameters, all starting with YY (leading YY will be discarded)
my(%params)=(YYLEX => 'CODE', 'YYERROR' => 'CODE', YYVERSION => '',
			 YYRULES => 'ARRAY', YYSTATES => 'ARRAY', YYDEBUG => '');
#Mandatory parameters
my(@params)=('LEX','RULES','STATES');

sub new {
    my($class)=shift;
	my($errst,$nberr,$token,$value,$check,$dotpos);
    my($self)={ ERROR => \&_Error,
				ERRST => \$errst,
                NBERR => \$nberr,
				TOKEN => \$token,
				VALUE => \$value,
				DOTPOS => \$dotpos,
				STACK => [],
				DEBUG => 0,
				CHECK => \$check };

	_CheckParams( [], \%params, \@_, $self );

		exists($$self{VERSION})
	and	$$self{VERSION} < $COMPATIBLE
	and	croak "Yapp driver version $VERSION ".
			  "incompatible with version $$self{VERSION}:\n".
			  "Please recompile parser module.";

        ref($class)
    and $class=ref($class);

    bless($self,$class);
}

sub YYParse {
    my($self)=shift;
    my($retval);

	_CheckParams( \@params, \%params, \@_, $self );

	if($$self{DEBUG}) {
		_DBLoad();
		$retval = eval '$self->_DBParse()';#Do not create stab entry on compile
        $@ and die $@;
	}
	else {
		$retval = $self->_Parse();
	}
    $retval
}

sub YYData {
	my($self)=shift;

		exists($$self{USER})
	or	$$self{USER}={};

	$$self{USER};
	
}

sub YYErrok {
	my($self)=shift;

	${$$self{ERRST}}=0;
    undef;
}

sub YYNberr {
	my($self)=shift;

	${$$self{NBERR}};
}

sub YYRecovering {
	my($self)=shift;

	${$$self{ERRST}} != 0;
}

sub YYAbort {
	my($self)=shift;

	${$$self{CHECK}}='ABORT';
    undef;
}

sub YYAccept {
	my($self)=shift;

	${$$self{CHECK}}='ACCEPT';
    undef;
}

sub YYError {
	my($self)=shift;

	${$$self{CHECK}}='ERROR';
    undef;
}

sub YYSemval {
	my($self)=shift;
	my($index)= $_[0] - ${$$self{DOTPOS}} - 1;

		$index < 0
	and	-$index <= @{$$self{STACK}}
	and	return $$self{STACK}[$index][1];

	undef;	#Invalid index
}

sub YYCurtok {
	my($self)=shift;

        @_
    and ${$$self{TOKEN}}=$_[0];
    ${$$self{TOKEN}};
}

sub YYCurval {
	my($self)=shift;

        @_
    and ${$$self{VALUE}}=$_[0];
    ${$$self{VALUE}};
}

sub YYExpect {
    my($self)=shift;

    keys %{$self->{STATES}[$self->{STACK}[-1][0]]{ACTIONS}}
}

sub YYLexer {
    my($self)=shift;

	$$self{LEX};
}


#################
# Private stuff #
#################


sub _CheckParams {
	my($mandatory,$checklist,$inarray,$outhash)=@_;
	my($prm,$value);
	my($prmlst)={};

	while(($prm,$value)=splice(@$inarray,0,2)) {
        $prm=uc($prm);
			exists($$checklist{$prm})
		or	croak("Unknow parameter '$prm'");
			ref($value) eq $$checklist{$prm}
		or	croak("Invalid value for parameter '$prm'");
        $prm=unpack('@2A*',$prm);
		$$outhash{$prm}=$value;
	}
	for (@$mandatory) {
			exists($$outhash{$_})
		or	croak("Missing mandatory parameter '".lc($_)."'");
	}
}

sub _Error {
	print "Parse error.\n";
}

sub _DBLoad {
	{
		no strict 'refs';

			exists(${__PACKAGE__.'::'}{_DBParse})#Already loaded ?
		and	return;
	}
	my($fname)=__FILE__;
	my(@drv);
	open(DRV,"<$fname") or die "Report this as a BUG: Cannot open $fname";
	while(<DRV>) {
                	/^\s*sub\s+_Parse\s*{\s*$/ .. /^\s*}\s*#\s*_Parse\s*$/
        	and     do {
                	s/^#DBG>//;
                	push(@drv,$_);
        	}
	}
	close(DRV);

	$drv[0]=~s/_P/_DBP/;
	eval join('',@drv);
}

#Note that for loading debugging version of the driver,
#this file will be parsed from 'sub _Parse' up to '}#_Parse' inclusive.
#So, DO NOT remove comment at end of sub !!!
sub _Parse {
    my($self)=shift;

	my($rules,$states,$lex,$error)
     = @$self{ 'RULES', 'STATES', 'LEX', 'ERROR' };
	my($errstatus,$nberror,$token,$value,$stack,$check,$dotpos)
     = @$self{ 'ERRST', 'NBERR', 'TOKEN', 'VALUE', 'STACK', 'CHECK', 'DOTPOS' };

#DBG>	my($debug)=$$self{DEBUG};
#DBG>	my($dbgerror)=0;

#DBG>	my($ShowCurToken) = sub {
#DBG>		my($tok)='>';
#DBG>		for (split('',$$token)) {
#DBG>			$tok.=		(ord($_) < 32 or ord($_) > 126)
#DBG>					?	sprintf('<%02X>',ord($_))
#DBG>					:	$_;
#DBG>		}
#DBG>		$tok.='<';
#DBG>	};

	$$errstatus=0;
	$$nberror=0;
	($$token,$$value)=(undef,undef);
	@$stack=( [ 0, undef ] );
	$$check='';

    while(1) {
        my($actions,$act,$stateno);

        $stateno=$$stack[-1][0];
        $actions=$$states[$stateno];

#DBG>	print STDERR ('-' x 40),"\n";
#DBG>		$debug & 0x2
#DBG>	and	print STDERR "In state $stateno:\n";
#DBG>		$debug & 0x08
#DBG>	and	print STDERR "Stack:[".
#DBG>					 join(',',map { $$_[0] } @$stack).
#DBG>					 "]\n";


        if  (exists($$actions{ACTIONS})) {

				defined($$token)
            or	do {
				($$token,$$value)=&$lex($self);
#DBG>				$debug & 0x01
#DBG>			and	print STDERR "Need token. Got ".&$ShowCurToken."\n";
			};

            $act=   exists($$actions{ACTIONS}{$$token})
                    ?   $$actions{ACTIONS}{$$token}
                    :   exists($$actions{DEFAULT})
                        ?   $$actions{DEFAULT}
                        :   undef;
        }
        else {
            $act=$$actions{DEFAULT};
#DBG>			$debug & 0x01
#DBG>		and	print STDERR "Don't need token.\n";
        }

            defined($act)
        and do {

                $act > 0
            and do {        #shift

#DBG>				$debug & 0x04
#DBG>			and	print STDERR "Shift and go to state $act.\n";

					$$errstatus
				and	do {
					--$$errstatus;

#DBG>					$debug & 0x10
#DBG>				and	$dbgerror
#DBG>				and	$$errstatus == 0
#DBG>				and	do {
#DBG>					print STDERR "**End of Error recovery.\n";
#DBG>					$dbgerror=0;
#DBG>				};
				};


                push(@$stack,[ $act, $$value ]);

					$$token ne ''	#Don't eat the eof
				and	$$token=$$value=undef;
                next;
            };

            #reduce
            my($lhs,$len,$code,@sempar,$semval);
            ($lhs,$len,$code)=@{$$rules[-$act]};

#DBG>			$debug & 0x04
#DBG>		and	$act
#DBG>		and	print STDERR "Reduce using rule ".-$act." ($lhs,$len): ";

                $act
            or  $self->YYAccept();

            $$dotpos=$len;

                unpack('A1',$lhs) eq '@'    #In line rule
            and do {
                    $lhs =~ /^\@[0-9]+\-([0-9]+)$/
                or  die "In line rule name '$lhs' ill formed: ".
                        "report it as a BUG.\n";
                $$dotpos = $1;
            };

            @sempar =       $$dotpos
                        ?   map { $$_[1] } @$stack[ -$$dotpos .. -1 ]
                        :   ();

            $semval = $code ? &$code( $self, @sempar )
                            : @sempar ? $sempar[0] : undef;

            splice(@$stack,-$len,$len);

                $$check eq 'ACCEPT'
            and do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Accept.\n";

				return($semval);
			};

                $$check eq 'ABORT'
            and	do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Abort.\n";

				return(undef);

			};

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Back to state $$stack[-1][0], then ";

                $$check eq 'ERROR'
            or  do {
#DBG>				$debug & 0x04
#DBG>			and	print STDERR 
#DBG>				    "go to state $$states[$$stack[-1][0]]{GOTOS}{$lhs}.\n";

#DBG>				$debug & 0x10
#DBG>			and	$dbgerror
#DBG>			and	$$errstatus == 0
#DBG>			and	do {
#DBG>				print STDERR "**End of Error recovery.\n";
#DBG>				$dbgerror=0;
#DBG>			};

			    push(@$stack,
                     [ $$states[$$stack[-1][0]]{GOTOS}{$lhs}, $semval ]);
                $$check='';
                next;
            };

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Forced Error recovery.\n";

            $$check='';

        };

        #Error
            $$errstatus
        or   do {

            $$errstatus = 1;
            &$error($self);
                $$errstatus # if 0, then YYErrok has been called
            or  next;       # so continue parsing

#DBG>			$debug & 0x10
#DBG>		and	do {
#DBG>			print STDERR "**Entering Error recovery.\n";
#DBG>			++$dbgerror;
#DBG>		};

            ++$$nberror;

        };

			$$errstatus == 3	#The next token is not valid: discard it
		and	do {
				$$token eq ''	# End of input: no hope
			and	do {
#DBG>				$debug & 0x10
#DBG>			and	print STDERR "**At eof: aborting.\n";
				return(undef);
			};

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Dicard invalid token ".&$ShowCurToken.".\n";

			$$token=$$value=undef;
		};

        $$errstatus=3;

		while(	  @$stack
			  and (		not exists($$states[$$stack[-1][0]]{ACTIONS})
			        or  not exists($$states[$$stack[-1][0]]{ACTIONS}{error})
					or	$$states[$$stack[-1][0]]{ACTIONS}{error} <= 0)) {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Pop state $$stack[-1][0].\n";

			pop(@$stack);
		}

			@$stack
		or	do {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**No state left on stack: aborting.\n";

			return(undef);
		};

		#shift the error token

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Shift \$error token and go to state ".
#DBG>						 $$states[$$stack[-1][0]]{ACTIONS}{error}.
#DBG>						 ".\n";

		push(@$stack, [ $$states[$$stack[-1][0]]{ACTIONS}{error}, undef ]);

    }

    #never reached
	croak("Error in driver logic. Please, report it as a BUG");

}#_Parse
#DO NOT remove comment

1;

}
#End of include--------------------------------------------------


#line 1 "./Parse.yp"

#
# Parse.pm
#
# Copyright (C) 2008, 2009 Francesco Salvestrini
#                          Alessandro Massignan
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#

use 5.8.0;

use warnings;
use strict;
use diagnostics;

use Choicetool::Autoconfig;
use Choicetool::Base::Trace;
use Choicetool::Base::Debug;
use Choicetool::OS::File;

use Choicetool::Data::Set;
use Choicetool::Data::Stack;

use Choicetool::Widgets::Widget;
use Choicetool::Widgets::Menu;
use Choicetool::Widgets::Window;
use Choicetool::Widgets::ConfigboxEnum;
use Choicetool::Widgets::ConfigboxNumber;
use Choicetool::Widgets::ConfigboxString;

use Choicetool::Binder;

BEGIN {
    use Exporter ();
    our ($VERSION, @ISA, @EXPORT);

    @ISA    = qw(Exporter);
    @EXPORT = qw(&parse);
}

#
# XXX FIX ME:
#   remove global variables ASAP
#

my $parser_data;

my $parse_help_text = 0;
my $help_start      = 0;
my $lineno          = 0;

sub dtoken ($)
{
    my $string = shift;

    assert(defined($string));

    debug("Found token: " . $string);
}

sub drule ($)
{
    my $string = shift;

    assert(defined($string));

    debug("Get rule: " . $string);
}

sub add_window_widget ($$$)
{
    my $widget_ref    = shift;
    my $widget_id_ref = shift;
    my $stack_ref     = shift;

    assert(defined($$widget_ref));
    assert($$widget_ref->id() == 0);
    assert($$widget_id_ref >= 0);
    assert(defined($stack_ref));
    assert($$stack_ref->size() == 1);

    my $widget_data = $$stack_ref->pop();
    assert(defined($widget_data));
    assert(defined($widget_data->{TITLE}));

    my $window = Choicetool::Widgets::Window->new(++$$widget_id_ref);
    assert(defined($window));

    $window->title($widget_data->{TITLE});

    my $root_ref      = $$widget_ref->root();
    my @root_children = $$root_ref->children();

    for (my $i = 0; $i <= $#root_children; $i++) {
	my $child_ref = $$root_ref->child($i);

	if (!defined($child_ref)) {
	    next;
	}

	if (!$window->add_child($$child_ref->id(), $child_ref)) {
	    error("Failed to add child to window widget [" .
		  $$child_ref->id()                        .
		  "]");
	    return 0;
	}

	$$child_ref->parent(\$window);
	$$root_ref->remove_child($i);
    }

     if (!$$root_ref->add_child($window->id(), \$window)) {
	 error("Failed to add child to root widget [" .
	       $window->id()                          .
	       "]");
	 return 0;
     }

     $window->parent($root_ref);

     $$widget_ref = $$root_ref;

    return 1;
}

sub add_menu_widget ($$$)
{
    my $widget_ref    = shift;
    my $widget_id_ref = shift;
    my $stack_ref     = shift;

    assert(defined($$widget_ref));
    assert($$widget_id_ref >= 0);
    assert(defined($stack_ref));
    assert($$stack_ref->size() > 1);

    my $widget_data = $$stack_ref->pop();
    assert(defined($widget_data));
    assert(defined($widget_data->{LABEL}));

    my $menu = Choicetool::Widgets::Menu->new(++$$widget_id_ref);
    assert(defined($menu));

    $menu->label($widget_data->{LABEL});

    if ($$widget_ref->id() == 0) {

	if (!$$widget_ref->add_child($menu->id(), \$menu)) {
	    error("Failed to add children to parent widget [" .
		  $$widget_ref->id()                          .
		  "]");
	    return 0;
	}

	$menu->parent($widget_ref);

	return 1;
    }

    my $widget = $$widget_ref;
    assert(!defined($widget->parent()));

    $widget->parent(\$menu);

    if (!$menu->add_child($$widget_ref->id(), \$widget)) {
	error("Failed to add children to menu widget [" .
	      $$widget_id_ref                           .
	      "]");
	return 0;
    }

    $$widget_ref = $menu;

    return 1;
}

sub add_configbox_widget($$$)
{
    my $widget_ref    = shift;
    my $widget_id_ref = shift;
    my $stack_ref     = shift;

    assert(defined($$widget_ref));
    assert($$widget_id_ref >= 0);
    assert(defined($stack_ref));
    assert($$stack_ref->size() > 1);

    my $widget_data = $$stack_ref->pop();
    assert(defined($widget_data));
    assert(defined($widget_data->{TYPE}));
    assert(defined($widget_data->{SYMBOL}));

    my $type = $widget_data->{TYPE};
    delete $widget_data->{TYPE};

    if ($type eq "bool") {
	@{$widget_data->{ENUM}} = ["y", "n"];
	$$stack_ref->push($widget_data);

	if (!add_configboxenum_widget($widget_ref,
				      $widget_id_ref,
				      $stack_ref)) {
	    return 0;
	}
    } elsif ($type eq "tristate") {
	@{$widget_data->{ENUM}} = ["y", "n", "m"];
	$$stack_ref->push($widget_data);

	if (!add_configboxenum_widget($widget_ref,
				      $widget_id_ref,
				      $stack_ref)) {
	    return 0;
	}
     } elsif ($type eq "int") {
	$widget_data->{BASE} = 10;
	$$stack_ref->push($widget_data);

	if (!add_configboxnumber_widget($widget_ref,
					$widget_id_ref,
					$stack_ref)) {
	    return 0;
	}
    } elsif ($type eq "hex") {
	$widget_data->{BASE} = 16;
	$$stack_ref->push($widget_data);

	if (!add_configboxnumber_widget($widget_ref,
					$widget_id_ref,
					$stack_ref)) {
	    return 0;
	}
    } elsif ($type eq "string") {
	$$stack_ref->push($widget_data);

	if (!add_configboxstring_widget($widget_ref,
					$widget_id_ref,
					$stack_ref)) {
	    return 0;
	}
    } else {
	bug("Unreachable code, got type '$type'");
    }

    return 1;
}

sub add_configboxenum_widget ($$$)
{
    my $widget_ref    = shift;
    my $widget_id_ref = shift;
    my $stack_ref     = shift;

    assert(defined($$widget_ref));
    assert($$widget_id_ref >= 0);
    assert(defined($stack_ref));

    my $widget_data = $$stack_ref->pop();
    assert(defined($widget_data));
    assert(defined($widget_data->{SYMBOL}));
    assert($#{$widget_data->{ENUM}} > -1);

    my $configbox =
	Choicetool::Widgets::ConfigboxEnum->new(++$$widget_id_ref);
    assert(defined($configbox));

    $configbox->symbol($widget_data->{SYMBOL});
    $configbox->enum(@{$widget_data->{ENUM}});

    if (defined($widget_data->{TITLE})) {
	$configbox->title($widget_data->{TITLE});
    }

    if ($$widget_ref->id() == 0) {

	if (!$$widget_ref->add_child($configbox->id(), \$configbox)) {
	    error("Failed to add children to parent widget [" .
		  $$widget_ref->id()                          .
		  "]");
	    return 0;
	}

	$configbox->parent($widget_ref);

	return 1;
    }

    my $widget = $$widget_ref;
    assert(!defined($widget->parent()));

    $widget->parent(\$configbox);

    if (!$configbox->add_child($$widget_ref->id(), \$widget)) {
	error("Failed to add children to config box widget [" .
	      $$widget_id_ref                                 .
	      "]");
	return 0;
    }

    $$widget_ref = $configbox;

    return 1;
}

sub add_configboxnumber_widget ($$$)
{
    my $widget_ref    = shift;
    my $widget_id_ref = shift;
    my $stack_ref     = shift;

    assert(defined($$widget_ref));
    assert($$widget_id_ref >= 0);
    assert(defined($stack_ref));

    my $widget_data = $$stack_ref->pop();
    assert(defined($widget_data));
    assert(defined($widget_data->{SYMBOL}));
    assert(defined($widget_data->{BASE}));

    my $configbox =
	Choicetool::Widgets::ConfigboxNumber->new(++$$widget_id_ref);
    assert(defined($configbox));

    $configbox->symbol($widget_data->{SYMBOL});
    $configbox->base($widget_data->{BASE});

    if (defined($widget_data->{TITLE})) {
	$configbox->title($widget_data->{TITLE});
    }

    if ($$widget_ref->id() == 0) {

	if (!$$widget_ref->add_child($configbox->id(), \$configbox)) {
	    error("Failed to add children to parent widget [" .
		  $$widget_ref->id()                          .
		  "]");
	    return 0;
	}

	$configbox->parent($widget_ref);

	return 1;
    }

    my $widget = $$widget_ref;
    assert(!defined($widget->parent()));

    $widget->parent(\$configbox);

    if (!$configbox->add_child($$widget_ref->id(), \$widget)) {
	error("Failed to add children to config box  widget [" .
	      $$widget_id_ref                                  .
	      "]");
	return 0;
    }

     $$widget_ref = $configbox;

    return 1;
}

sub add_configboxstring_widget ($$$)
{
    my $widget_ref    = shift;
    my $widget_id_ref = shift;
    my $stack_ref     = shift;

    assert(defined($$widget_ref));
    assert($$widget_id_ref >= 0);
    assert(defined($stack_ref));

    my $widget_data = $$stack_ref->pop();
    assert(defined($widget_data));
    assert(defined($widget_data->{SYMBOL}));

    my $configbox =
	Choicetool::Widgets::ConfigboxString->new(++$$widget_id_ref);
    assert(defined($configbox));

    $configbox->symbol($widget_data->{SYMBOL});

    if (defined($widget_data->{TITLE})) {
	$configbox->title($widget_data->{TITLE});
    }

    if ($$widget_ref->id() == 0) {

	if (!$$widget_ref->add_child($configbox->id(), \$configbox)) {
	    error("Failed to add children to parent widget [" .
		  $$widget_ref->id()                          .
		  "]");
	    return 0;
	}

	$configbox->parent($widget_ref);

	return 1;
    }

    my $widget = $$widget_ref;
    assert(!defined($widget->parent()));

    $widget->parent(\$configbox);

    if (!$configbox->add_child($$widget_ref->id(), \$widget)) {
	error("Failed to add children to config box widget [" .
	      $$widget_id_ref                                 .
	      "]");
	return 0;
    }

    $$widget_ref = $configbox;

    return 1;
}



sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    my($self)=$class->SUPER::new( yyversion => '1.05',
                                  yystates =>
[
	{#State 0
		ACTIONS => {
			"T_MAINMENU" => 1,
			"T_COMMENT" => 4,
			"T_CONFIG" => 7,
			"T_EOL" => 10,
			"T_IF" => 13,
			"T_MENUCONFIG" => 14,
			"T_MENU" => 17,
			"T_CHOICE" => 28
		},
		DEFAULT => -1,
		GOTOS => {
			'input' => 3,
			'menu_entry' => 2,
			'comment_stmt' => 5,
			'choice_stmt' => 8,
			'menuconfig_entry' => 6,
			'menu_stmt' => 9,
			'stmt_list' => 11,
			'comment_entry' => 12,
			'choice_entry' => 16,
			'if_stmt' => 15,
			'newline' => 19,
			'config_stmt' => 18,
			'if_entry' => 20,
			'menuconfig_stmt' => 21,
			'mainmenu_stmt' => 22,
			'newlines' => 23,
			'menu' => 24,
			'common_stmt' => 26,
			'config_entry' => 25,
			'stmt' => 27
		}
	},
	{#State 1
		ACTIONS => {
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'words' => 29
		}
	},
	{#State 2
		ACTIONS => {
			"T_IF" => 13,
			"T_MENUCONFIG" => 14,
			"T_COMMENT" => 4,
			"T_CHOICE" => 28,
			"T_MENU" => 17,
			"T_ENDMENU" => 37,
			"T_CONFIG" => 7
		},
		GOTOS => {
			'menu_entry' => 2,
			'comment_stmt' => 5,
			'choice_stmt' => 34,
			'menuconfig_entry' => 6,
			'menu_stmt' => 35,
			'comment_entry' => 12,
			'if_stmt' => 15,
			'choice_entry' => 16,
			'config_stmt' => 18,
			'if_entry' => 20,
			'menuconfig_stmt' => 21,
			'menu_block' => 36,
			'menu' => 24,
			'config_entry' => 25,
			'common_stmt' => 38,
			'menu_block_list' => 39
		}
	},
	{#State 3
		ACTIONS => {
			'' => 40
		}
	},
	{#State 4
		ACTIONS => {
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'words' => 41
		}
	},
	{#State 5
		DEFAULT => -68
	},
	{#State 6
		ACTIONS => {
			"T_DEF_BOOL" => 42,
			"T_HELP" => 46,
			"T_RANGE" => 45,
			"T_STRING" => 44,
			"T_HEX" => 43,
			"T_SELECT" => 48,
			"T_INT" => 50,
			"T_REQUIRES" => 52,
			"T_BOOL" => 51,
			"T_PROMPT" => 54,
			"T_TRISTATE" => 56,
			"T_DEPENDS" => 58,
			"T_DEF_TRISTATE" => 60,
			"T_DEFAULT" => 61,
			"T_OPTION" => 62
		},
		DEFAULT => -116,
		GOTOS => {
			'config_type_default_definition' => 57,
			'symbol_option' => 47,
			'config_options_block' => 49,
			'config_option' => 59,
			'help' => 53,
			'config_options_block_list' => 55,
			'config_type_definition' => 63,
			'depends' => 64
		}
	},
	{#State 7
		ACTIONS => {
			"T_WORD" => 33
		},
		GOTOS => {
			'word' => 65
		}
	},
	{#State 8
		DEFAULT => -12
	},
	{#State 9
		DEFAULT => -11
	},
	{#State 10
		DEFAULT => -7
	},
	{#State 11
		DEFAULT => -3
	},
	{#State 12
		ACTIONS => {
			"T_DEPENDS" => 58,
			"T_REQUIRES" => 52
		},
		DEFAULT => -113,
		GOTOS => {
			'depends_list' => 66,
			'depends' => 67
		}
	},
	{#State 13
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 70,
			'words' => 69
		}
	},
	{#State 14
		ACTIONS => {
			"T_WORD" => 33
		},
		GOTOS => {
			'word' => 72
		}
	},
	{#State 15
		DEFAULT => -67
	},
	{#State 16
		ACTIONS => {
			"T_IF" => 13,
			"T_ENDCHOICE" => 75,
			"T_MENUCONFIG" => 14,
			"T_COMMENT" => 4,
			"T_CONFIG" => 7
		},
		GOTOS => {
			'if_entry' => 20,
			'menuconfig_stmt' => 21,
			'choice_block_list' => 73,
			'comment_stmt' => 5,
			'menuconfig_entry' => 6,
			'common_stmt' => 74,
			'config_entry' => 25,
			'comment_entry' => 12,
			'if_stmt' => 15,
			'config_stmt' => 18
		}
	},
	{#State 17
		ACTIONS => {
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'words' => 76
		}
	},
	{#State 18
		DEFAULT => -66
	},
	{#State 19
		ACTIONS => {
			"T_EOL" => 10
		},
		DEFAULT => -5,
		GOTOS => {
			'newlines' => 77,
			'newline' => 19
		}
	},
	{#State 20
		ACTIONS => {
			"T_IF" => 13,
			"T_MENUCONFIG" => 14,
			"T_COMMENT" => 4,
			"T_CHOICE" => 28,
			"T_MENU" => 17,
			"T_CONFIG" => 7,
			"T_ENDIF" => 82
		},
		GOTOS => {
			'if_entry' => 20,
			'menuconfig_stmt' => 21,
			'menu_entry' => 2,
			'menu' => 24,
			'comment_stmt' => 5,
			'choice_stmt' => 78,
			'menuconfig_entry' => 6,
			'config_entry' => 25,
			'common_stmt' => 81,
			'menu_stmt' => 79,
			'comment_entry' => 12,
			'if_block_list' => 83,
			'if_block' => 80,
			'choice_entry' => 16,
			'if_stmt' => 15,
			'config_stmt' => 18
		}
	},
	{#State 21
		DEFAULT => -69
	},
	{#State 22
		DEFAULT => -10
	},
	{#State 23
		ACTIONS => {
			"T_MAINMENU" => 1,
			"T_COMMENT" => 4,
			"T_CONFIG" => 7,
			"T_IF" => 13,
			"T_MENUCONFIG" => 14,
			"T_MENU" => 17,
			"T_CHOICE" => 28
		},
		DEFAULT => -2,
		GOTOS => {
			'menu_entry' => 2,
			'comment_stmt' => 5,
			'choice_stmt' => 8,
			'menuconfig_entry' => 6,
			'menu_stmt' => 9,
			'stmt_list' => 84,
			'comment_entry' => 12,
			'choice_entry' => 16,
			'if_stmt' => 15,
			'config_stmt' => 18,
			'if_entry' => 20,
			'menuconfig_stmt' => 21,
			'mainmenu_stmt' => 22,
			'menu' => 24,
			'config_entry' => 25,
			'common_stmt' => 26,
			'stmt' => 27
		}
	},
	{#State 24
		ACTIONS => {
			"T_DEPENDS" => 58,
			"T_REQUIRES" => 52
		},
		DEFAULT => -21,
		GOTOS => {
			'depends_list' => 85,
			'depends' => 67
		}
	},
	{#State 25
		ACTIONS => {
			"T_DEF_BOOL" => 42,
			"T_HELP" => 46,
			"T_RANGE" => 45,
			"T_STRING" => 44,
			"T_HEX" => 43,
			"T_SELECT" => 48,
			"T_INT" => 50,
			"T_REQUIRES" => 52,
			"T_BOOL" => 51,
			"T_PROMPT" => 54,
			"T_TRISTATE" => 56,
			"T_DEPENDS" => 58,
			"T_DEF_TRISTATE" => 60,
			"T_DEFAULT" => 61,
			"T_OPTION" => 62
		},
		DEFAULT => -70,
		GOTOS => {
			'config_type_default_definition' => 57,
			'symbol_option' => 47,
			'config_options_block' => 49,
			'config_option' => 59,
			'help' => 53,
			'config_options_block_list' => 86,
			'config_type_definition' => 63,
			'depends' => 64
		}
	},
	{#State 26
		DEFAULT => -13
	},
	{#State 27
		ACTIONS => {
			"T_MAINMENU" => 1,
			"T_COMMENT" => 4,
			"T_CONFIG" => 7,
			"T_IF" => 13,
			"T_MENUCONFIG" => 14,
			"T_MENU" => 17,
			"T_CHOICE" => 28
		},
		DEFAULT => -8,
		GOTOS => {
			'menu_entry' => 2,
			'comment_stmt' => 5,
			'choice_stmt' => 8,
			'menuconfig_entry' => 6,
			'menu_stmt' => 9,
			'stmt_list' => 87,
			'comment_entry' => 12,
			'choice_entry' => 16,
			'if_stmt' => 15,
			'config_stmt' => 18,
			'if_entry' => 20,
			'menuconfig_stmt' => 21,
			'mainmenu_stmt' => 22,
			'menu' => 24,
			'config_entry' => 25,
			'common_stmt' => 26,
			'stmt' => 27
		}
	},
	{#State 28
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 88,
			'newline' => 19
		}
	},
	{#State 29
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 89,
			'newline' => 19
		}
	},
	{#State 30
		DEFAULT => -16
	},
	{#State 31
		DEFAULT => -18
	},
	{#State 32
		DEFAULT => -15
	},
	{#State 33
		DEFAULT => -17
	},
	{#State 34
		DEFAULT => -27
	},
	{#State 35
		DEFAULT => -26
	},
	{#State 36
		ACTIONS => {
			"T_COMMENT" => 4,
			"T_CONFIG" => 7,
			"T_IF" => 13,
			"T_MENUCONFIG" => 14,
			"T_MENU" => 17,
			"T_CHOICE" => 28
		},
		DEFAULT => -24,
		GOTOS => {
			'menu_entry' => 2,
			'comment_stmt' => 5,
			'choice_stmt' => 34,
			'menuconfig_entry' => 6,
			'menu_stmt' => 35,
			'comment_entry' => 12,
			'if_stmt' => 15,
			'choice_entry' => 16,
			'config_stmt' => 18,
			'if_entry' => 20,
			'menuconfig_stmt' => 21,
			'menu_block' => 36,
			'menu' => 24,
			'config_entry' => 25,
			'common_stmt' => 38,
			'menu_block_list' => 90
		}
	},
	{#State 37
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 91,
			'newline' => 19
		}
	},
	{#State 38
		DEFAULT => -28
	},
	{#State 39
		ACTIONS => {
			"T_ENDMENU" => 92
		}
	},
	{#State 40
		DEFAULT => 0
	},
	{#State 41
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 93,
			'newline' => 19
		}
	},
	{#State 42
		DEFAULT => -98
	},
	{#State 43
		DEFAULT => -95
	},
	{#State 44
		DEFAULT => -94
	},
	{#State 45
		ACTIONS => {
			"T_WORD" => 33
		},
		GOTOS => {
			'word' => 94
		}
	},
	{#State 46
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 95,
			'newline' => 19
		}
	},
	{#State 47
		DEFAULT => -76
	},
	{#State 48
		ACTIONS => {
			"T_WORD" => 33
		},
		GOTOS => {
			'word' => 96
		}
	},
	{#State 49
		ACTIONS => {
			"T_DEF_BOOL" => 42,
			"T_HELP" => 46,
			"T_RANGE" => 45,
			"T_STRING" => 44,
			"T_HEX" => 43,
			"T_SELECT" => 48,
			"T_INT" => 50,
			"T_REQUIRES" => 52,
			"T_BOOL" => 51,
			"T_PROMPT" => 54,
			"T_TRISTATE" => 56,
			"T_DEPENDS" => 58,
			"T_DEF_TRISTATE" => 60,
			"T_DEFAULT" => 61,
			"T_OPTION" => 62
		},
		DEFAULT => -73,
		GOTOS => {
			'config_type_default_definition' => 57,
			'symbol_option' => 47,
			'config_options_block' => 49,
			'config_option' => 59,
			'help' => 53,
			'config_options_block_list' => 97,
			'config_type_definition' => 63,
			'depends' => 64
		}
	},
	{#State 50
		DEFAULT => -96
	},
	{#State 51
		DEFAULT => -92
	},
	{#State 52
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 98,
			'words' => 69
		}
	},
	{#State 53
		DEFAULT => -78
	},
	{#State 54
		ACTIONS => {
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'words' => 99
		}
	},
	{#State 55
		DEFAULT => -117
	},
	{#State 56
		DEFAULT => -93
	},
	{#State 57
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 100,
			'words' => 69
		}
	},
	{#State 58
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_ON" => 102,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 101,
			'words' => 69
		}
	},
	{#State 59
		DEFAULT => -75
	},
	{#State 60
		DEFAULT => -97
	},
	{#State 61
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 103,
			'words' => 69
		}
	},
	{#State 62
		ACTIONS => {
			"T_EOL" => 10,
			"T_WORD" => 33
		},
		GOTOS => {
			'symbol_options_block' => 104,
			'symbol_options_block_list' => 105,
			'word' => 107,
			'newlines' => 106,
			'newline' => 19
		}
	},
	{#State 63
		ACTIONS => {
			"T_WORD_QUOTE" => 31,
			"T_EOL" => 10,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'newlines' => 109,
			'newline' => 19,
			'words' => 108
		}
	},
	{#State 64
		DEFAULT => -77
	},
	{#State 65
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 110,
			'newline' => 19
		}
	},
	{#State 66
		DEFAULT => -114
	},
	{#State 67
		ACTIONS => {
			"T_DEPENDS" => 58,
			"T_REQUIRES" => 52
		},
		DEFAULT => -29,
		GOTOS => {
			'depends_list' => 111,
			'depends' => 67
		}
	},
	{#State 68
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 112,
			'words' => 69
		}
	},
	{#State 69
		ACTIONS => {
			"T_EQUAL" => 113,
			"T_UNEQUAL" => 114
		},
		DEFAULT => -34
	},
	{#State 70
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 117,
			'newline' => 19
		}
	},
	{#State 71
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 118,
			'words' => 69
		}
	},
	{#State 72
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 119,
			'newline' => 19
		}
	},
	{#State 73
		ACTIONS => {
			"T_ENDCHOICE" => 120
		}
	},
	{#State 74
		ACTIONS => {
			"T_IF" => 13,
			"T_MENUCONFIG" => 14,
			"T_COMMENT" => 4,
			"T_CONFIG" => 7
		},
		DEFAULT => -64,
		GOTOS => {
			'if_entry' => 20,
			'menuconfig_stmt' => 21,
			'choice_block_list' => 121,
			'comment_stmt' => 5,
			'menuconfig_entry' => 6,
			'common_stmt' => 74,
			'config_entry' => 25,
			'comment_entry' => 12,
			'if_stmt' => 15,
			'config_stmt' => 18
		}
	},
	{#State 75
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 122,
			'newline' => 19
		}
	},
	{#State 76
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 123,
			'newline' => 19
		}
	},
	{#State 77
		DEFAULT => -6
	},
	{#State 78
		DEFAULT => -112
	},
	{#State 79
		DEFAULT => -111
	},
	{#State 80
		ACTIONS => {
			"T_IF" => 13,
			"T_MENUCONFIG" => 14,
			"T_COMMENT" => 4,
			"T_CHOICE" => 28,
			"T_MENU" => 17,
			"T_CONFIG" => 7
		},
		DEFAULT => -108,
		GOTOS => {
			'if_entry' => 20,
			'menuconfig_stmt' => 21,
			'menu_entry' => 2,
			'menu' => 24,
			'comment_stmt' => 5,
			'choice_stmt' => 78,
			'menuconfig_entry' => 6,
			'config_entry' => 25,
			'common_stmt' => 81,
			'menu_stmt' => 79,
			'comment_entry' => 12,
			'if_block_list' => 124,
			'if_block' => 80,
			'choice_entry' => 16,
			'if_stmt' => 15,
			'config_stmt' => 18
		}
	},
	{#State 81
		DEFAULT => -110
	},
	{#State 82
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 125,
			'newline' => 19
		}
	},
	{#State 83
		ACTIONS => {
			"T_ENDIF" => 126
		}
	},
	{#State 84
		DEFAULT => -4
	},
	{#State 85
		DEFAULT => -22
	},
	{#State 86
		DEFAULT => -71
	},
	{#State 87
		DEFAULT => -9
	},
	{#State 88
		ACTIONS => {
			"T_STRING" => 128,
			"T_HEX" => 127,
			"T_HELP" => 46,
			"T_OPTIONAL" => 129,
			"T_INT" => 131,
			"T_BOOL" => 132,
			"T_REQUIRES" => 52,
			"T_PROMPT" => 137,
			"T_TRISTATE" => 138,
			"T_DEPENDS" => 58,
			"T_DEFAULT" => 139
		},
		DEFAULT => -43,
		GOTOS => {
			'choice_option' => 134,
			'choice_type_definition' => 133,
			'choice_options_block_list' => 135,
			'help' => 136,
			'choice_options_block' => 130,
			'depends' => 140
		}
	},
	{#State 89
		DEFAULT => -14
	},
	{#State 90
		DEFAULT => -25
	},
	{#State 91
		DEFAULT => -19
	},
	{#State 92
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 141,
			'newline' => 19
		}
	},
	{#State 93
		DEFAULT => -115
	},
	{#State 94
		ACTIONS => {
			"T_WORD" => 33
		},
		GOTOS => {
			'word' => 142
		}
	},
	{#State 95
		ACTIONS => {
			"T_HELPTEXT" => 143
		}
	},
	{#State 96
		ACTIONS => {
			"T_IF" => 144,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 145,
			'newline' => 19
		}
	},
	{#State 97
		DEFAULT => -74
	},
	{#State 98
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 146,
			'newline' => 19
		}
	},
	{#State 99
		ACTIONS => {
			"T_IF" => 147,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 148,
			'newline' => 19
		}
	},
	{#State 100
		ACTIONS => {
			"T_OR" => 115,
			"T_IF" => 149,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 150,
			'newline' => 19
		}
	},
	{#State 101
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 151,
			'newline' => 19
		}
	},
	{#State 102
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 152,
			'words' => 69
		}
	},
	{#State 103
		ACTIONS => {
			"T_OR" => 115,
			"T_IF" => 153,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 154,
			'newline' => 19
		}
	},
	{#State 104
		ACTIONS => {
			"T_WORD" => 33
		},
		DEFAULT => -101,
		GOTOS => {
			'symbol_options_block' => 104,
			'symbol_options_block_list' => 155,
			'word' => 107
		}
	},
	{#State 105
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 156,
			'newline' => 19
		}
	},
	{#State 106
		DEFAULT => -99
	},
	{#State 107
		ACTIONS => {
			"T_EQUAL" => 157
		},
		DEFAULT => -103
	},
	{#State 108
		ACTIONS => {
			"T_IF" => 158,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 159,
			'newline' => 19
		}
	},
	{#State 109
		DEFAULT => -83
	},
	{#State 110
		DEFAULT => -72
	},
	{#State 111
		DEFAULT => -30
	},
	{#State 112
		DEFAULT => -38
	},
	{#State 113
		ACTIONS => {
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'words' => 160
		}
	},
	{#State 114
		ACTIONS => {
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'words' => 161
		}
	},
	{#State 115
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 162,
			'words' => 69
		}
	},
	{#State 116
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 163,
			'words' => 69
		}
	},
	{#State 117
		DEFAULT => -107
	},
	{#State 118
		ACTIONS => {
			"T_OR" => 115,
			"T_CLOSE_PAREN" => 164,
			"T_AND" => 116
		}
	},
	{#State 119
		DEFAULT => -118
	},
	{#State 120
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 165,
			'newline' => 19
		}
	},
	{#State 121
		DEFAULT => -65
	},
	{#State 122
		DEFAULT => -41
	},
	{#State 123
		DEFAULT => -23
	},
	{#State 124
		DEFAULT => -109
	},
	{#State 125
		DEFAULT => -105
	},
	{#State 126
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 166,
			'newline' => 19
		}
	},
	{#State 127
		DEFAULT => -61
	},
	{#State 128
		DEFAULT => -60
	},
	{#State 129
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 167,
			'newline' => 19
		}
	},
	{#State 130
		ACTIONS => {
			"T_STRING" => 128,
			"T_HEX" => 127,
			"T_HELP" => 46,
			"T_OPTIONAL" => 129,
			"T_INT" => 131,
			"T_BOOL" => 132,
			"T_REQUIRES" => 52,
			"T_PROMPT" => 137,
			"T_TRISTATE" => 138,
			"T_DEPENDS" => 58,
			"T_DEFAULT" => 139
		},
		DEFAULT => -45,
		GOTOS => {
			'choice_option' => 134,
			'choice_type_definition' => 133,
			'choice_options_block_list' => 168,
			'help' => 136,
			'choice_options_block' => 130,
			'depends' => 140
		}
	},
	{#State 131
		DEFAULT => -62
	},
	{#State 132
		DEFAULT => -58
	},
	{#State 133
		ACTIONS => {
			"T_WORD_QUOTE" => 31,
			"T_EOL" => 10,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'newlines' => 170,
			'newline' => 19,
			'words' => 169
		}
	},
	{#State 134
		DEFAULT => -47
	},
	{#State 135
		DEFAULT => -44
	},
	{#State 136
		DEFAULT => -49
	},
	{#State 137
		ACTIONS => {
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'words' => 171
		}
	},
	{#State 138
		DEFAULT => -59
	},
	{#State 139
		ACTIONS => {
			"T_WORD" => 33
		},
		GOTOS => {
			'word' => 172
		}
	},
	{#State 140
		DEFAULT => -48
	},
	{#State 141
		DEFAULT => -20
	},
	{#State 142
		ACTIONS => {
			"T_IF" => 173,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 174,
			'newline' => 19
		}
	},
	{#State 143
		ACTIONS => {
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 175,
			'newline' => 19
		}
	},
	{#State 144
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 176,
			'words' => 69
		}
	},
	{#State 145
		DEFAULT => -88
	},
	{#State 146
		DEFAULT => -33
	},
	{#State 147
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 177,
			'words' => 69
		}
	},
	{#State 148
		DEFAULT => -84
	},
	{#State 149
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 178,
			'words' => 69
		}
	},
	{#State 150
		DEFAULT => -79
	},
	{#State 151
		DEFAULT => -32
	},
	{#State 152
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 179,
			'newline' => 19
		}
	},
	{#State 153
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 180,
			'words' => 69
		}
	},
	{#State 154
		DEFAULT => -86
	},
	{#State 155
		DEFAULT => -102
	},
	{#State 156
		DEFAULT => -100
	},
	{#State 157
		ACTIONS => {
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'words' => 181
		}
	},
	{#State 158
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 182,
			'words' => 69
		}
	},
	{#State 159
		DEFAULT => -82
	},
	{#State 160
		DEFAULT => -35
	},
	{#State 161
		DEFAULT => -36
	},
	{#State 162
		DEFAULT => -39
	},
	{#State 163
		ACTIONS => {
			"T_OR" => 115
		},
		DEFAULT => -40
	},
	{#State 164
		DEFAULT => -37
	},
	{#State 165
		DEFAULT => -42
	},
	{#State 166
		DEFAULT => -106
	},
	{#State 167
		DEFAULT => -55
	},
	{#State 168
		DEFAULT => -46
	},
	{#State 169
		ACTIONS => {
			"T_IF" => 183,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 184,
			'newline' => 19
		}
	},
	{#State 170
		DEFAULT => -54
	},
	{#State 171
		ACTIONS => {
			"T_IF" => 185,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 186,
			'newline' => 19
		}
	},
	{#State 172
		ACTIONS => {
			"T_IF" => 187,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 188,
			'newline' => 19
		}
	},
	{#State 173
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 189,
			'words' => 69
		}
	},
	{#State 174
		DEFAULT => -90
	},
	{#State 175
		DEFAULT => -63
	},
	{#State 176
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 190,
			'newline' => 19
		}
	},
	{#State 177
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 191,
			'newline' => 19
		}
	},
	{#State 178
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 192,
			'newline' => 19
		}
	},
	{#State 179
		DEFAULT => -31
	},
	{#State 180
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 193,
			'newline' => 19
		}
	},
	{#State 181
		DEFAULT => -104
	},
	{#State 182
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 194,
			'newline' => 19
		}
	},
	{#State 183
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 195,
			'words' => 69
		}
	},
	{#State 184
		DEFAULT => -53
	},
	{#State 185
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 196,
			'words' => 69
		}
	},
	{#State 186
		DEFAULT => -50
	},
	{#State 187
		ACTIONS => {
			"T_OPEN_PAREN" => 71,
			"T_NOT" => 68,
			"T_WORD_QUOTE" => 31,
			"T_WORD" => 33
		},
		GOTOS => {
			'word_quote' => 30,
			'word' => 32,
			'expr' => 197,
			'words' => 69
		}
	},
	{#State 188
		DEFAULT => -56
	},
	{#State 189
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 198,
			'newline' => 19
		}
	},
	{#State 190
		DEFAULT => -89
	},
	{#State 191
		DEFAULT => -85
	},
	{#State 192
		DEFAULT => -80
	},
	{#State 193
		DEFAULT => -87
	},
	{#State 194
		DEFAULT => -81
	},
	{#State 195
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 199,
			'newline' => 19
		}
	},
	{#State 196
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 200,
			'newline' => 19
		}
	},
	{#State 197
		ACTIONS => {
			"T_OR" => 115,
			"T_AND" => 116,
			"T_EOL" => 10
		},
		GOTOS => {
			'newlines' => 201,
			'newline' => 19
		}
	},
	{#State 198
		DEFAULT => -91
	},
	{#State 199
		DEFAULT => -52
	},
	{#State 200
		DEFAULT => -51
	},
	{#State 201
		DEFAULT => -57
	}
],
                                  yyrules  =>
[
	[#Rule 0
		 '$start', 2, undef
	],
	[#Rule 1
		 'input', 0, undef
	],
	[#Rule 2
		 'input', 1,
sub
#line 443 "./Parse.yp"
{
    drule("input");

    assert($$parser_data->{STACK}->size() == 1);
    $$parser_data->{STACK}->pop();
    assert($$parser_data->{STACK}->is_empty());
}
	],
	[#Rule 3
		 'input', 1,
sub
#line 451 "./Parse.yp"
{
    drule("input");

    if (!add_window_widget($$parser_data->{WIDGET},
			   \$$parser_data->{WIDGET_ID},
			   \$$parser_data->{STACK})) {
	$_[0]->YYAbort;
    }
}
	],
	[#Rule 4
		 'input', 2,
sub
#line 461 "./Parse.yp"
{
    drule("input");

    if (!add_window_widget($$parser_data->{WIDGET},
			   \$$parser_data->{WIDGET_ID},
			   \$$parser_data->{STACK})) {
	$_[0]->YYAbort;
    }
}
	],
	[#Rule 5
		 'newlines', 1,
sub
#line 473 "./Parse.yp"
{
    drule("newlines");
}
	],
	[#Rule 6
		 'newlines', 2, undef
	],
	[#Rule 7
		 'newline', 1,
sub
#line 480 "./Parse.yp"
{
    $lineno++;
    drule("newline");
}
	],
	[#Rule 8
		 'stmt_list', 1,
sub
#line 487 "./Parse.yp"
{
    drule("stmt_list");
}
	],
	[#Rule 9
		 'stmt_list', 2, undef
	],
	[#Rule 10
		 'stmt', 1,
sub
#line 494 "./Parse.yp"
{
    drule("stmt");
}
	],
	[#Rule 11
		 'stmt', 1,
sub
#line 498 "./Parse.yp"
{
    drule("stmt");

    if (!add_menu_widget($$parser_data->{WIDGET},
			 \$$parser_data->{WIDGET_ID},
			 \$$parser_data->{STACK})) {
	$_[0]->YYAbort;
    }
}
	],
	[#Rule 12
		 'stmt', 1,
sub
#line 508 "./Parse.yp"
{
    drule("menu_block");
}
	],
	[#Rule 13
		 'stmt', 1,
sub
#line 512 "./Parse.yp"
{
    drule("menu_block");
}
	],
	[#Rule 14
		 'mainmenu_stmt', 3,
sub
#line 518 "./Parse.yp"
{
    drule("mainmenu_stmt");

    assert($$parser_data->{STACK}->size() > 0);

    my $mainmenu_data = $$parser_data->{STACK}->pop();
    assert(defined($mainmenu_data->{TITLE} eq ""));

    $mainmenu_data->{TITLE} = $$parser_data->{BUFFER};

    $$parser_data->{STACK}->push($mainmenu_data);
}
	],
	[#Rule 15
		 'words', 1,
sub
#line 533 "./Parse.yp"
{
    drule("words");
}
	],
	[#Rule 16
		 'words', 1,
sub
#line 537 "./Parse.yp"
{
    drule("words");
}
	],
	[#Rule 17
		 'word', 1,
sub
#line 543 "./Parse.yp"
{
    assert(defined($_[1]));

    debug("Storing word: \`" . $_[1] . "'");
    $$parser_data->{BUFFER} = $_[1];

    drule("word");
}
	],
	[#Rule 18
		 'word_quote', 1,
sub
#line 554 "./Parse.yp"
{
    assert(defined($_[1]));

    debug("Storing quoted word: \`" . $_[1] . "'");
    $$parser_data->{BUFFER} = $_[1];

    drule("word_quote");
}
	],
	[#Rule 19
		 'menu_stmt', 3,
sub
#line 565 "./Parse.yp"
{
    drule("menu_stmt");
}
	],
	[#Rule 20
		 'menu_stmt', 4,
sub
#line 569 "./Parse.yp"
{
    drule("menu_stmt");
}
	],
	[#Rule 21
		 'menu_entry', 1,
sub
#line 575 "./Parse.yp"
{
    drule("menu_entry");
}
	],
	[#Rule 22
		 'menu_entry', 2,
sub
#line 579 "./Parse.yp"
{
    drule("menu_entry");
}
	],
	[#Rule 23
		 'menu', 3,
sub
#line 585 "./Parse.yp"
{
    drule("menu");

    my $menu_data;

    $menu_data->{LABEL} = $$parser_data->{BUFFER};

    $$parser_data->{STACK}->push($menu_data);
}
	],
	[#Rule 24
		 'menu_block_list', 1,
sub
#line 597 "./Parse.yp"
{
    drule("menu_block_list");
}
	],
	[#Rule 25
		 'menu_block_list', 2, undef
	],
	[#Rule 26
		 'menu_block', 1,
sub
#line 604 "./Parse.yp"
{
    drule("menu_block");

    if (!add_menu_widget($$parser_data->{WIDGET},
			 \$$parser_data->{WIDGET_ID},
			 \$$parser_data->{STACK})) {
	$_[0]->YYAbort;
    }
}
	],
	[#Rule 27
		 'menu_block', 1,
sub
#line 614 "./Parse.yp"
{
    drule("menu_block");
}
	],
	[#Rule 28
		 'menu_block', 1,
sub
#line 618 "./Parse.yp"
{
    drule("menu_block");
}
	],
	[#Rule 29
		 'depends_list', 1,
sub
#line 624 "./Parse.yp"
{
    drule("depends_list");
}
	],
	[#Rule 30
		 'depends_list', 2, undef
	],
	[#Rule 31
		 'depends', 4,
sub
#line 631 "./Parse.yp"
{
    drule("depends");
}
	],
	[#Rule 32
		 'depends', 3,
sub
#line 635 "./Parse.yp"
{
    drule("depends");
}
	],
	[#Rule 33
		 'depends', 3,
sub
#line 639 "./Parse.yp"
{
    drule("depends");
}
	],
	[#Rule 34
		 'expr', 1,
sub
#line 645 "./Parse.yp"
{
    drule("expr");
}
	],
	[#Rule 35
		 'expr', 3,
sub
#line 649 "./Parse.yp"
{
    drule("expr");
}
	],
	[#Rule 36
		 'expr', 3,
sub
#line 653 "./Parse.yp"
{
    drule("expr");
}
	],
	[#Rule 37
		 'expr', 3,
sub
#line 657 "./Parse.yp"
{
    drule("expr");
}
	],
	[#Rule 38
		 'expr', 2,
sub
#line 661 "./Parse.yp"
{
    drule("expr");
}
	],
	[#Rule 39
		 'expr', 3,
sub
#line 665 "./Parse.yp"
{
    drule("expr");
}
	],
	[#Rule 40
		 'expr', 3,
sub
#line 669 "./Parse.yp"
{
    drule("expr");
}
	],
	[#Rule 41
		 'choice_stmt', 3,
sub
#line 675 "./Parse.yp"
{
    drule("choice_stmt");
}
	],
	[#Rule 42
		 'choice_stmt', 4,
sub
#line 679 "./Parse.yp"
{
    drule("choice_stmt");
}
	],
	[#Rule 43
		 'choice_entry', 2,
sub
#line 685 "./Parse.yp"
{
    drule("choice_entry");
}
	],
	[#Rule 44
		 'choice_entry', 3,
sub
#line 689 "./Parse.yp"
{
    drule("choice_entry");
}
	],
	[#Rule 45
		 'choice_options_block_list', 1,
sub
#line 695 "./Parse.yp"
{
    drule("choice_options_block_list");
}
	],
	[#Rule 46
		 'choice_options_block_list', 2, undef
	],
	[#Rule 47
		 'choice_options_block', 1,
sub
#line 702 "./Parse.yp"
{
    drule("choice_options_block");
}
	],
	[#Rule 48
		 'choice_options_block', 1,
sub
#line 706 "./Parse.yp"
{
    drule("choice_options_block");
}
	],
	[#Rule 49
		 'choice_options_block', 1,
sub
#line 710 "./Parse.yp"
{
    drule("choice_options_block");
}
	],
	[#Rule 50
		 'choice_option', 3,
sub
#line 716 "./Parse.yp"
{
    drule("choice_option");
}
	],
	[#Rule 51
		 'choice_option', 5,
sub
#line 720 "./Parse.yp"
{
    drule("choice_option");
}
	],
	[#Rule 52
		 'choice_option', 5,
sub
#line 724 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 53
		 'choice_option', 3,
sub
#line 728 "./Parse.yp"
{
    drule("choice_option");
}
	],
	[#Rule 54
		 'choice_option', 2,
sub
#line 732 "./Parse.yp"
{
    drule("choice_option");
}
	],
	[#Rule 55
		 'choice_option', 2,
sub
#line 736 "./Parse.yp"
{
    drule("choice_option");
}
	],
	[#Rule 56
		 'choice_option', 3,
sub
#line 740 "./Parse.yp"
{
    drule("choice_option");
}
	],
	[#Rule 57
		 'choice_option', 5,
sub
#line 744 "./Parse.yp"
{
    drule("choice_option");
}
	],
	[#Rule 58
		 'choice_type_definition', 1,
sub
#line 750 "./Parse.yp"
{
    drule("type_definition");
}
	],
	[#Rule 59
		 'choice_type_definition', 1,
sub
#line 754 "./Parse.yp"
{
    drule("type_definition");
}
	],
	[#Rule 60
		 'choice_type_definition', 1,
sub
#line 758 "./Parse.yp"
{
    drule("type_definition");
}
	],
	[#Rule 61
		 'choice_type_definition', 1,
sub
#line 762 "./Parse.yp"
{
    drule("type_definition");
}
	],
	[#Rule 62
		 'choice_type_definition', 1,
sub
#line 766 "./Parse.yp"
{
    drule("type_definition");
}
	],
	[#Rule 63
		 'help', 4,
sub
#line 772 "./Parse.yp"
{
    drule("help");
}
	],
	[#Rule 64
		 'choice_block_list', 1,
sub
#line 778 "./Parse.yp"
{
    drule("choice_block_list");
}
	],
	[#Rule 65
		 'choice_block_list', 2, undef
	],
	[#Rule 66
		 'common_stmt', 1,
sub
#line 785 "./Parse.yp"
{
    drule("common_stmt");
}
	],
	[#Rule 67
		 'common_stmt', 1,
sub
#line 789 "./Parse.yp"
{
    drule("common_stmt");
}
	],
	[#Rule 68
		 'common_stmt', 1,
sub
#line 793 "./Parse.yp"
{
    drule("common_stmt");
}
	],
	[#Rule 69
		 'common_stmt', 1,
sub
#line 797 "./Parse.yp"
{
    drule("common_stmt");
}
	],
	[#Rule 70
		 'config_stmt', 1,
sub
#line 803 "./Parse.yp"
{
    drule("config_stmt");

    my $data = $$parser_data->{STACK}->pop();

    if (!defined($data->{TYPE})) {
	error("Config symbol defined without a type");
	$_[0]->YYAbort();
    } else {
	$$parser_data->{STACK}->push($data);

	if (!add_configbox_widget($$parser_data->{WIDGET},
				  \$$parser_data->{WIDGET_ID},
				  \$$parser_data->{STACK})) {
	    $_[0]->YYAbort;
	}
    }
}
	],
	[#Rule 71
		 'config_stmt', 2,
sub
#line 822 "./Parse.yp"
{
    drule("config_stmt");

    my $data = $$parser_data->{STACK}->pop();

    if (!defined($data->{TYPE})) {
	error("Config symbol defined without a type");
	$_[0]->YYAbort();
    } else {
	$$parser_data->{STACK}->push($data);

	if (!add_configbox_widget($$parser_data->{WIDGET},
				  \$$parser_data->{WIDGET_ID},
				  \$$parser_data->{STACK})) {
	    $_[0]->YYAbort;
	}
    }
}
	],
	[#Rule 72
		 'config_entry', 3,
sub
#line 843 "./Parse.yp"
{
    drule("config_entry");

    my $config_data;

    $config_data->{SYMBOL}  = $$parser_data->{BUFFER};
    $config_data->{DEFAULT} = "";

    $$parser_data->{STACK}->push($config_data);
}
	],
	[#Rule 73
		 'config_options_block_list', 1,
sub
#line 856 "./Parse.yp"
{
    drule("config_options_block_list");
}
	],
	[#Rule 74
		 'config_options_block_list', 2, undef
	],
	[#Rule 75
		 'config_options_block', 1,
sub
#line 863 "./Parse.yp"
{
    drule("config_options_block");
}
	],
	[#Rule 76
		 'config_options_block', 1,
sub
#line 867 "./Parse.yp"
{
    drule("config_options_block");
}
	],
	[#Rule 77
		 'config_options_block', 1,
sub
#line 871 "./Parse.yp"
{
    drule("config_options_block");
}
	],
	[#Rule 78
		 'config_options_block', 1,
sub
#line 875 "./Parse.yp"
{
    drule("config_options_block");
}
	],
	[#Rule 79
		 'config_option', 3,
sub
#line 881 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 80
		 'config_option', 5,
sub
#line 885 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 81
		 'config_option', 5,
sub
#line 889 "./Parse.yp"
{
    drule("config_option");

    my $data = $$parser_data->{STACK}->pop();
    assert(defined($data));

    $data->{TITLE} = $$parser_data->{BUFFER};

    $$parser_data->{STACK}->push($data);
}
	],
	[#Rule 82
		 'config_option', 3,
sub
#line 900 "./Parse.yp"
{
    drule("config_option");

    my $data = $$parser_data->{STACK}->pop();
    assert(defined($data));

    $data->{TITLE} = $$parser_data->{BUFFER};

    $$parser_data->{STACK}->push($data);
}
	],
	[#Rule 83
		 'config_option', 2,
sub
#line 911 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 84
		 'config_option', 3,
sub
#line 915 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 85
		 'config_option', 5,
sub
#line 919 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 86
		 'config_option', 3,
sub
#line 923 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 87
		 'config_option', 5,
sub
#line 927 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 88
		 'config_option', 3,
sub
#line 931 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 89
		 'config_option', 5,
sub
#line 935 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 90
		 'config_option', 4,
sub
#line 939 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 91
		 'config_option', 6,
sub
#line 943 "./Parse.yp"
{
    drule("config_option");
}
	],
	[#Rule 92
		 'config_type_definition', 1,
sub
#line 949 "./Parse.yp"
{
    drule("type_definition");

    my $data = $$parser_data->{STACK}->pop();
    assert(defined($data));

    if (defined($data->{TYPE})) {
	error("Type is already defined");
	$_[0]->YYAbort();
    }
    $data->{TYPE} = "bool";

    $$parser_data->{STACK}->push($data);
}
	],
	[#Rule 93
		 'config_type_definition', 1,
sub
#line 964 "./Parse.yp"
{
    drule("type_definition");

    my $data = $$parser_data->{STACK}->pop();
    assert(defined($data));

    if (defined($data->{TYPE})) {
	error("Type is already defined");
	$_[0]->YYAbort();
    }
    $data->{TYPE} = "tristate";

    $$parser_data->{STACK}->push($data);
}
	],
	[#Rule 94
		 'config_type_definition', 1,
sub
#line 979 "./Parse.yp"
{
    drule("type_definition");

    my $data = $$parser_data->{STACK}->pop();
    assert(defined($data));

    if (defined($data->{TYPE})) {
	error("Type is already defined");
	$_[0]->YYAbort();
    }
    $data->{TYPE} = "string";

    $$parser_data->{STACK}->push($data);
}
	],
	[#Rule 95
		 'config_type_definition', 1,
sub
#line 994 "./Parse.yp"
{
    drule("type_definition");

    my $data = $$parser_data->{STACK}->pop();
    assert(defined($data));

    if (defined($data->{TYPE})) {
	error("Type is already defined");
	$_[0]->YYAbort();
    }

    $data->{TYPE} = "hex";

    $$parser_data->{STACK}->push($data);
}
	],
	[#Rule 96
		 'config_type_definition', 1,
sub
#line 1010 "./Parse.yp"
{
    drule("type_definition");


    my $data = $$parser_data->{STACK}->pop();
    assert(defined($data));

    if (defined($data->{TYPE})) {
	error("Type is already defined");
	$_[0]->YYAbort();
    }
    $data->{TYPE} = "int";

    $$parser_data->{STACK}->push($data);
}
	],
	[#Rule 97
		 'config_type_default_definition', 1,
sub
#line 1028 "./Parse.yp"
{
    drule("type_default_definition");

    my $data = $$parser_data->{STACK}->pop();
    assert(defined($data));

    if (defined($data->{TYPE})) {
	error("Type is already defined");
	$_[0]->YYAbort();
    }
    $data->{TYPE} = "tristate";

    $$parser_data->{STACK}->push($data);
}
	],
	[#Rule 98
		 'config_type_default_definition', 1,
sub
#line 1043 "./Parse.yp"
{
    drule("type_default_definition");

    my $data = $$parser_data->{STACK}->pop();
    assert(defined($data));

    if (defined($data->{TYPE})) {
	error("Type is already defined");
	$_[0]->YYAbort();
    }
    $data->{TYPE} = "bool";

    $$parser_data->{STACK}->push($data);
}
	],
	[#Rule 99
		 'symbol_option', 2,
sub
#line 1060 "./Parse.yp"
{
    drule("symbol_option");
}
	],
	[#Rule 100
		 'symbol_option', 3,
sub
#line 1064 "./Parse.yp"
{
    drule("symbol_option");
}
	],
	[#Rule 101
		 'symbol_options_block_list', 1,
sub
#line 1070 "./Parse.yp"
{
    drule("symbol_options_block_list");
}
	],
	[#Rule 102
		 'symbol_options_block_list', 2, undef
	],
	[#Rule 103
		 'symbol_options_block', 1,
sub
#line 1077 "./Parse.yp"
{
    drule("symbol_options_block");
}
	],
	[#Rule 104
		 'symbol_options_block', 3,
sub
#line 1081 "./Parse.yp"
{
    drule("symbol_options_block");
}
	],
	[#Rule 105
		 'if_stmt', 3,
sub
#line 1087 "./Parse.yp"
{
    drule("if_stmt");
}
	],
	[#Rule 106
		 'if_stmt', 4,
sub
#line 1091 "./Parse.yp"
{
    drule("if_stmt");
}
	],
	[#Rule 107
		 'if_entry', 3,
sub
#line 1097 "./Parse.yp"
{
    drule("if_entry");
}
	],
	[#Rule 108
		 'if_block_list', 1,
sub
#line 1103 "./Parse.yp"
{
    debug("if_block_list");
}
	],
	[#Rule 109
		 'if_block_list', 2, undef
	],
	[#Rule 110
		 'if_block', 1,
sub
#line 1110 "./Parse.yp"
{
    debug("if_block");
}
	],
	[#Rule 111
		 'if_block', 1,
sub
#line 1114 "./Parse.yp"
{
    debug("if_block");

    if (!add_menu_widget($$parser_data->{WIDGET},
			 \$$parser_data->{WIDGET_ID},
			 \$$parser_data->{STACK})) {
	$_[0]->YYAbort;
    }
}
	],
	[#Rule 112
		 'if_block', 1,
sub
#line 1124 "./Parse.yp"
{
    debug("if_block");
}
	],
	[#Rule 113
		 'comment_stmt', 1,
sub
#line 1130 "./Parse.yp"
{
    drule("comment_stmt");
}
	],
	[#Rule 114
		 'comment_stmt', 2,
sub
#line 1134 "./Parse.yp"
{
    drule("comment_stmt");
}
	],
	[#Rule 115
		 'comment_entry', 3,
sub
#line 1140 "./Parse.yp"
{
    drule("comment_entry");
}
	],
	[#Rule 116
		 'menuconfig_stmt', 1,
sub
#line 1146 "./Parse.yp"
{
    drule("menuconfig_stmt");
}
	],
	[#Rule 117
		 'menuconfig_stmt', 2,
sub
#line 1150 "./Parse.yp"
{
    drule("menuconfig_stmt");
}
	],
	[#Rule 118
		 'menuconfig_entry', 3,
sub
#line 1156 "./Parse.yp"
{
    drule("menuconfig_stmt");
}
	]
],
                                  @_);
    bless($self,$class);
}

#line 1161 "./Parse.yp"


sub parse_help_text ($$)
{
    my $stream_ref  = shift;
    my $string_ref  = shift;
    my $ws_length;

    assert(defined($$stream_ref));
    assert(defined($$string_ref));

    while ($$stream_ref =~ s/^([^\n]*)(\n?)//) {
	my $string = $1;

	if (defined($2)) {
	    $lineno++;
	}

	if ($string =~ s/^([ \t]*)$//) {
	    $$string_ref = $$string_ref . "\n";

	} elsif ($string =~ s/^([ \t]+)(.+)$//) {
	    my $ws             = $1;
	    my $text           = $2;
	    my $curr_ws_length = 0;
	    my $tmp            = $ws;

	    for (my $i = 0; $i < length($ws); $i++) {
		$tmp =~ s/^(.)//;

		if ($1 =~ /\ /) {
		    $curr_ws_length++;
		} elsif ($1 =~ /\t/) {
		    $curr_ws_length = ($curr_ws_length & ~7) + 8;
		} else {
		    bug("Unreachable!");
		}
	    }

	    if (!defined($ws_length)) {
		$ws_length = $curr_ws_length;
	    }

	    if ($curr_ws_length < $ws_length) {
		$$stream_ref = $ws . $text . "\n" . $$stream_ref;

		$lineno--;
		last;
	    }

	    if ($curr_ws_length > $ws_length) {
		$text = " " x ($curr_ws_length - $ws_length) . $text;
	    }

	    $$string_ref = $$string_ref . $text . "\n";

	} elsif ($string =~ s/^([^ \t])(.*)$//) {

	    if (defined($2)) {
		$$stream_ref = $1 . $2 . "\n" . $$stream_ref;
	    } else {
		$$stream_ref = $1 . "\n". $$stream_ref;
	    }

	    $lineno--;
	    last;
	} else {
	    bug("Unreachable!");
	}
    }

    $$string_ref =~ s/\s+$//;

    # XXX FIX ME:
    # A weak solution... Review this sub as soon as possible.
    $$stream_ref = "\n" . $$stream_ref;

    return 1;
}

sub parse_quoted_text ($$$)
{
    my $stream_ref      = shift;
    my $quoted_text_ref = shift;
    my $quoting_char    = shift;

    assert(defined($stream_ref));
    assert(defined($quoted_text_ref));
    assert(defined($quoting_char));

    if (($$stream_ref eq "")                ||
	((length($$stream_ref) == 1)        &&
	 ($$stream_ref ne "$quoting_char"))) {
	error("Multiline quoted string is not supported");
	return 0;
    }

    $$stream_ref      =~ s/^([^\n]+)//;
    $$quoted_text_ref = "";

    my $string = $1;

    while ($string ne "") {
	$string =~ s/^([^$quoting_char]+)//;

	if ((!defined($1)) && ($string eq "$quoting_char")) {
	    return 1;
	}
	my $tmp = $1;
	$string =~ s/^($quoting_char)//;

	if (!defined($1)) {
	    error("Multiline quoted string is not supported");
	    return 0;
	}

	$tmp       =~ /(.)$/;
	my $p_char = $1;

	if ($p_char eq "\\") {

	    if ($string eq "") {
		error("Multiline quoted string is not supported");
		return 0;
	    }
	    $$quoted_text_ref = $quoted_text_ref .
				$tmp             .
				$quoting_char;
	    next;
	}

	$$quoted_text_ref = $$quoted_text_ref . $tmp;
	$string           =~ s/^[ \t]*//;
	$$stream_ref      = $string . $$stream_ref;

	last;
    }

    return 1;
}

sub lexer_callback ($)
{
    my $parser     = shift;
    my $stream_ref = "";
    my $help_text  = "";
    my $buffer     = "";

    assert(defined($parser));
    $stream_ref = \$parser->YYData->{INPUT};

    if ($parse_help_text == 1) {

	if (!parse_help_text($stream_ref, \$help_text)) {
	    error("Failed to parse help text");
	    exit 1;
	}

	$parse_help_text = 0;
	$help_start      = 0;

	dtoken("T_HELPTEXT");

	return ('T_HELPTEXT', $help_text);
    }

    while ($$stream_ref =~ s/^\#[^\n]*//) {
	# Cleaning comments
    }

    # Removing useless whitespaces
    if ($help_start != 1) {
	$$stream_ref =~ s/^[ \t]*//;
    }

    while ($$stream_ref =~ s/^([^ \t]+)([ \t]*)//) {
	my $string;
	my $spaces;

	assert(defined($1));
	$string = $1;

	if (defined($2)) {
	    $spaces = $2;
	}

	# Handling newlines
	if ($string =~ s/^([^\n]+)//) {
	    my $new_string = $1;

	    if ($string ne "") {
		$$stream_ref = $string                             .
			       ((defined($spaces)) ? $spaces : "") .
			       $$stream_ref;
	    }
	    $string = $new_string;
	}

	my $return_token;
	my $return_text;

	#
	# Pay attention to the following if/substitution order,
	# it weighs upon right token recognition. For example
	# Don't put "bool" before "boolean" or the last will
	# never be recognized.
	#

	if ($string =~ s/^\n//) {
	    $return_token = "T_EOL";

	    if ($help_start == 1) {
		$parse_help_text = 1;
	    }
	} elsif ($string =~ s/^([\"\'])//) {
	    my $text;

	    $$stream_ref = (defined($string) ? $string : "") .
			   (defined($spaces) ? $spaces : "") .
			   $$stream_ref;
	    $string      = "";

	    if (!parse_quoted_text($stream_ref, \$text, $1)) {
		exit 1;
	    }
	    $return_token = "T_WORD_QUOTE";
	    $return_text  = $text;
	} elsif ($string =~ s/^\)//) {
	    $return_token = "T_CLOSE_PAREN";
	} elsif ($string =~ s/^\(//) {
	    $return_token = "T_OPEN_PAREN";
	} elsif ($string =~ s/^\!\=//) {
	    $return_token = "T_UNEQUAL";
	} elsif ($string =~ s/^\&\&//) {
	    $return_token = "T_AND";
	} elsif ($string =~ s/^\|\|//) {
	    $return_token = "T_OR";
	} elsif ($string =~ s/^\!//) {
	    $return_token = "T_NOT";
	} elsif ($string =~ s/^\=//) {
	    $return_token = "T_EQUAL";
	} elsif ($string =~ s/^def_tristate$//) {
	    $return_token = "T_DEF_TRISTATE";
	} elsif ($string =~ s/^menuconfig$//) {
	    $return_token = "T_MENUCONFIG";
	} elsif (($string =~ s/^def_boolean$//) ||
		 ($string =~ s/^def_bool$//))    {
	    $return_token = "T_DEF_BOOL";
	} elsif ($string =~ s/^endchoice$//) {
	    $return_token = "T_ENDCHOICE";
	} elsif ($string =~ s/^mainmenu$//) {
	    $return_token = "T_MAINMENU";
	} elsif ($string =~ s/^requires$//) {
	    $return_token = "T_REQUIRES";
	} elsif ($string =~ s/^optional$//) {
	    $return_token = "T_OPTIONAL";
	} elsif ($string =~ s/^tristate$//) {
	    $return_token = "T_TRISTATE";
	} elsif ($string =~ s/^endmenu$//) {
	    $return_token = "T_ENDMENU";
	} elsif ($string =~ s/^comment$//) {
	    $return_token = "T_COMMENT";
	} elsif ($string =~ s/^depends$//) {
	    $return_token = "T_DEPENDS";
	} elsif ($string =~ s/^default$//) {
	    $return_token = "T_DEFAULT";
	} elsif ($string =~ s/^select$//) {
	    $return_token = "T_SELECT";
	} elsif ($string =~ s/^config$//) {
	    $return_token = "T_CONFIG";
	} elsif ($string =~ s/^string$//) {
	    $return_token = "T_STRING";
	} elsif ($string =~ s/^choice$//) {
	    $return_token = "T_CHOICE";
	} elsif ($string =~ s/^option$//) {
	    $return_token = "T_OPTION";
	} elsif ($string =~ s/^prompt$//) {
	    $return_token = "T_PROMPT";
	} elsif ($string =~ s/^endif$//) {
	    $return_token = "T_ENDIF";
	} elsif ($string =~ s/^range$//) {
	    $return_token = "T_RANGE";
	} elsif ($string =~ s/^menu$//) {
	    $return_token = "T_MENU";
	} elsif (($string =~ s/^boolean$//) ||
		 ($string =~ s/^bool$//))    {
	    $return_token = "T_BOOL";
	} elsif ($string =~ s/^hex$//) {
	    $return_token = "T_HEX";
	} elsif ($string =~ s/^int$//) {
	    $return_token = "T_INT";
	} elsif ($string =~ s/^if$//) {
	    $return_token = "T_IF";
	} elsif ($string =~ s/^on$//) {
	    $return_token = "T_ON";
	} elsif (($string =~ s/^help$//)        ||
		 ($string =~ s/^---help---$//))  {
	    $help_start  = 1;
	    $return_token = "T_HELP";
	} elsif ($string =~ s/^---$//) {
	    $$stream_ref = (defined($string) ? $string : "") .
			   (defined($spaces) ? $spaces : "") .
			   $$stream_ref;

	    if ($$stream_ref =~ s/^[ \t]*help[ \t]*\-\-\-//) {
		$help_start   = 1;
		$return_token = "T_HELP";
	    } else {
		error("Undefined lexer input \`" . $string .
		      "' at line \`"             . $lineno .
		      "'");
		exit 1;
	    }
	} elsif ($string =~ s/^([\-]?[A-Za-z0-9_]+)//) {
	    $return_token = "T_WORD";

	    assert(defined($1));
	    $return_text  = $1;
	} else {
	    undef($return_token);
	    undef($return_text);
	}

	if (!defined($return_token)) {
	    error("Undefined lexer input \`" . $string .
		  "' at line \`"             . $lineno .
		  "'");
	    exit 1;
	}

	if ($string ne "") {
	    $$stream_ref = $string                           .
			   (defined($spaces) ? $spaces : "") .
			   $$stream_ref;
	}

	if (defined($spaces) && ($parse_help_text == 1)) {
	    $$stream_ref = $spaces . $$stream_ref;
	}

	dtoken($return_token);

	return ($return_token,
		(defined($return_text)) ? $return_text : "");
    }
    return ('', undef);
}

sub syntax_error ($$)
{
    my $message = shift;
    my $lineno  = shift;

    assert(defined($message));
    assert(defined($lineno));

    error("Syntax error at line " . $lineno . ": " . $message);
    exit 1;
}

sub error_callback ($)
{
    my $parser = shift;

    assert(defined($parser));

    my $value = $parser->YYCurtok;
    assert(defined($value));

    error("Unexpected \`" . $value . "'");
}

sub parse ($$$)
{
    my $input_filename = shift;
    my $widget_ref     = shift;
    my $set_ref        = shift;

    assert(defined($input_filename));
    assert(defined($widget_ref));
    assert(defined($set_ref));

    debug("Parsing file \`" . $input_filename . "'");

    if (!file_ispresent($input_filename)) {
	return 0;
    }

    my $string;

    $string = "";
    if (!file_tostring($input_filename, \$string)) {
	return 0;
    }

    # Parse !
    my $parser;
    $parser = Choicetool::Frontends::KConfig::Parse->new();
    assert(defined($parser));

    $parser->YYData->{INPUT} = $string;
    $parser_data             = \$parser->YYData->{DATA}[0];

    # This is used to handle widget structure among the rules
    $$parser_data->{WIDGET}    = $widget_ref;
    $$parser_data->{WIDGET_ID} = 0;

    # This is used as temporary data stack
    $$parser_data->{STACK}     = Choicetool::Data::Stack->new();
    assert(defined($$parser_data->{STACK}));

    $$parser_data->{BUFFER}    = "";

    # Initialized empty mainmenu data
    my $tmp;
    $tmp->{TITLE} = "";
    $$parser_data->{STACK}->push($tmp);

    my $result;
    $result = $parser->YYParse(yylex   => \&lexer_callback,
			       yyerror => \&error_callback,
			       yydebug => 0x00);

    if (($parser->YYNberr() > 0) || (!defined($result))) {
	error("Cannot parse input file \`" . $input_filename . "'");
	return 0;
    }

    # Final checks
    assert(${$$parser_data->{WIDGET}}->is_root());
    assert($$parser_data->{STACK}->is_empty());

    debug("Parsing completed successfully");

    return 1;
}

1;
